=== modified file 'build.gradle'
--- build.gradle	2023-01-28 04:45:51 +0000
+++ build.gradle	2023-02-08 15:41:34 +0000
@@ -848,6 +848,7 @@
 
 task mergeMariaDBUDFs(dependsOn: 'makeManifests') {
     inputs.files('udf/mariadb/udfs.sql', 
+                 'udf/mariadb/guarded.sql', 
                  'udf/mariadb/error_handler.sql', 
                  "${buildDir}/udf/mariadb/getFWDVersion.sql")
     outputs.file( "${buildDir}/udf/mariadb/udfs.sql" )

=== modified file 'src/com/goldencode/p2j/persist/FQLPreprocessor.java'
--- src/com/goldencode/p2j/persist/FQLPreprocessor.java	2023-02-10 09:39:25 +0000
+++ src/com/goldencode/p2j/persist/FQLPreprocessor.java	2023-02-12 14:08:04 +0000
@@ -3319,18 +3319,8 @@
             int idxPos = next.getIndexPos();
             parent = (HQLAst) next.getParent();
             
-            String checkErrorFn = "checkError";
-            String initErrorFn = "initError";
-            if (dialect instanceof P2JSQLServer2008Dialect)
-            {
-               checkErrorFn = "dbo.checkError_bb"; 
-               initErrorFn = "dbo.initError_b";
-            }
-            if (useSQLUdfs)
-            {
-               checkErrorFn = udfSchema + checkErrorFn;
-               initErrorFn = udfSchema + initErrorFn;
-            }
+            String checkErrorFn = (useSQLUdfs ? udfSchema : "") + dialect.checkErrorFn();
+            String initErrorFn = (useSQLUdfs ? udfSchema : "") + dialect.initErrorFn();
             
             HQLAst checkErrFunc = createAstNode(FUNCTION, checkErrorFn, null);
             HQLAst initErrFunc = createAstNode(FUNCTION, initErrorFn, checkErrFunc);
@@ -3365,7 +3355,7 @@
                // as operand of the logical operators:
                needSQLBooleanConversion.add(checkErrFunc);
             }
-            if (dialect instanceof P2JPostgreSQLDialect)
+            if (useSQLUdfs)
             {
                Iterator<Aast> it = next.iterator();
                while (it.hasNext())
@@ -6361,6 +6351,12 @@
       {
          fn = fn.substring(udfSchema.length());
       }
+      int pos = fn.lastIndexOf("_");
+      if (pos > 0)
+      {
+         fn = fn.substring(0, pos);
+      }
+               
       return UdfNamesHolder.UDF_NAMES.contains(fn); 
    }
    

=== modified file 'src/com/goldencode/p2j/persist/dialect/Dialect.java'
--- src/com/goldencode/p2j/persist/dialect/Dialect.java	2023-01-28 04:45:51 +0000
+++ src/com/goldencode/p2j/persist/dialect/Dialect.java	2023-02-12 15:00:42 +0000
@@ -95,6 +95,7 @@
 **     SVL 20230110          P2JIndex.components() provides direct access to the components array in order to
 **                           improve performance.
 **     ECF 20230127          Added resolveBooleanConstant method.
+**     IAS 20230208          Dialect-specific error handler support.
 */
 
 /*
@@ -168,6 +169,7 @@
 import com.goldencode.p2j.persist.sequence.SequenceHandler;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.ErrorManager.*;
+import com.mchange.v2.c3p0.*;
 
 /**
  * Extends the API defined by Hibernate's abstract <code>Dialect</code> class
@@ -403,6 +405,7 @@
     */
    public abstract boolean useWordTables();
    
+   
    /**
     * Check if native UDFs are supported for the dialect
     * 
@@ -420,6 +423,24 @@
       return "";
    }
    
+   /** 
+    * Get name of the checkError UDF. 
+    * @return the name of the checkError UDF.  
+    */ 
+   public String checkErrorFn()
+   {
+      return "checkError";
+   }
+
+   /** 
+    * Get name of the initError UDF. 
+    * @return the name of the initError UDF.  
+    */ 
+   public String initErrorFn()
+   {
+      return "initError";
+   }
+
    /**
     * Check if the exception was caused by an error in UDF. 
     * @param e
@@ -493,6 +514,44 @@
    }
 
    /**
+    * Get c3p0 ConnectionCustomizer class for the dialect.
+    * 
+    * @param cfg 
+    *        Database configuration.
+    * @return c3p0 ConnectionCustomizer class for the dialect.
+    */
+   public Class<? extends AbstractConnectionCustomizer> connectionCustomizer(DatabaseConfig cfg)
+   {
+      return null;
+   }
+   
+   /**
+    * Activate error handler at the database side.
+    * @param  conn 
+    *         Database connection
+    * @throws SQLException
+    *         on error.
+    */
+   public void activateErrorHandler(Connection conn)
+   throws SQLException
+   {
+      
+   }
+   
+   /**
+    * Reset error handler at the database side.
+    * @param  conn 
+    *         Database connection
+    * @throws SQLException
+    *         on error.
+    */
+   public void resetErrorHandler(Connection conn)
+   throws SQLException
+   {
+      
+   }
+
+   /**
     * Worker method for {@code generateTriggerDDLs()}. It generates the DDLs needed to create all
     * triggers in a database with a specific schema and using a certain dialect.
     *

=== added file 'src/com/goldencode/p2j/persist/dialect/FWDMariaDBConnectionCustomizer.java'
--- src/com/goldencode/p2j/persist/dialect/FWDMariaDBConnectionCustomizer.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/persist/dialect/FWDMariaDBConnectionCustomizer.java	2023-02-12 14:57:59 +0000
@@ -0,0 +1,113 @@
+/*
+** Module   : FWDMariaDBConnectionCustomizer
+** Abstract : c3p0 connection customizer
+**
+** Copyright (c) 2023, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 IAS 20230208 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist.dialect;
+
+import java.sql.*;
+import org.slf4j.*;
+import com.goldencode.p2j.*;
+import com.mchange.v2.c3p0.*;
+
+/**
+ * Customizes the connection to database by setting up the {@code use.java.udfs} and {@code fwd.version}
+ * SQL configuration variable. 
+ */
+public class FWDMariaDBConnectionCustomizer 
+extends AbstractConnectionCustomizer
+{
+   /** Logger */
+   private static final Logger LOG = LoggerFactory.getLogger(FWDPostgreSQLConnectionCustomizer.class);
+   
+   /**
+    * Called immediately after a {@code Connection} is acquired from the underlying database for 
+    * incorporation into the pool.
+    *
+    * @param   c
+    *          Connection to be customized.
+    * @param   parentDataSourceIdentityToken
+    *          The parent data source identity token.
+    */
+   @Override
+   public void onAcquire(Connection c, String parentDataSourceIdentityToken)
+   throws java.lang.Exception 
+   {
+      // The database session user should be able to create temporary tables
+      // This can be granted by GRANT CREATE TEMPORARY TABLES ON *.* TO 'fwd_user'@'%';
+      try
+      {
+         c.prepareStatement(
+            "create temporary table if not exists "
+            + "temp_error_stack("
+            + "id integer not null auto_increment, "
+            + "state boolean not null, "
+            + "fwd_error_ctx text default @fwd_error_ctx, "
+            + "PRIMARY KEY (id)"
+            + ")"
+         ).executeUpdate();
+      }
+      catch(SQLException e)
+      {
+         LOG.warn("Failed to customize connection", e);
+      }
+   }
+}

=== renamed file 'src/com/goldencode/p2j/persist/dialect/FWDConnectionCustomizer.java' => 'src/com/goldencode/p2j/persist/dialect/FWDPostgreSQLConnectionCustomizer.java'
--- src/com/goldencode/p2j/persist/dialect/FWDConnectionCustomizer.java	2022-07-20 23:46:17 +0000
+++ src/com/goldencode/p2j/persist/dialect/FWDPostgreSQLConnectionCustomizer.java	2023-02-08 16:19:49 +0000
@@ -1,12 +1,13 @@
 /*
-** Module   : FWDConnectionCustomizer.java
+** Module   : FWDPostgreSQLConnectionCustomizer.java
 ** Abstract : c3p0 connection customizer
 **
-** Copyright (c) 2021-2022, Golden Code Development Corporation.
+** Copyright (c) 2021-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
 ** 001 IAS 20210803 Created initial version.
 **     OM  20220721 Added copyright statement, javadoc and updated formatting to GC standard.
+*      IAS 20230202 Renamed
 */
 
 /*
@@ -73,11 +74,11 @@
  * Customizes the connection to database by setting up the {@code use.java.udfs} and {@code fwd.version}
  * SQL configuration variable. 
  */
-public class FWDConnectionCustomizer
+public class FWDPostgreSQLConnectionCustomizer
 extends AbstractConnectionCustomizer
 {
    /** Logger */
-   private static final Logger LOG = LoggerFactory.getLogger(FWDConnectionCustomizer.class);
+   private static final Logger LOG = LoggerFactory.getLogger(FWDPostgreSQLConnectionCustomizer.class);
    
    /**
     * Called immediately after a {@code Connection} is acquired from the underlying database for 

=== modified file 'src/com/goldencode/p2j/persist/dialect/MariaDbLenientDialect.java'
--- src/com/goldencode/p2j/persist/dialect/MariaDbLenientDialect.java	2023-01-31 20:57:34 +0000
+++ src/com/goldencode/p2j/persist/dialect/MariaDbLenientDialect.java	2023-02-12 15:00:42 +0000
@@ -14,6 +14,7 @@
 **     BS  20230126 Added support for SAVE CACHE.
 **     ECF 20230127 Data type adjustment for SAVE CACHE.
 **     OM  20230131 Code cleanup.
+**     IAS 20230208 Added error handler support.
 */
 
 /*
@@ -78,6 +79,8 @@
 import com.goldencode.p2j.persist.sequence.*;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.ErrorManager.*;
+import com.mchange.v2.c3p0.*;
+
 import java.io.*;
 import java.sql.*;
 import java.sql.Date;
@@ -479,6 +482,48 @@
    }
    
    /**
+    * Get c3p0 ConnectionCustomizer class for the dialect.
+    * @param <T>
+    *        Customizer class  
+    * @param cfg 
+    *        Database configuration.
+    * @return c3p0 ConnectionCustomizer class for the dialect.
+    */
+   @Override
+   public Class<? extends AbstractConnectionCustomizer> connectionCustomizer(DatabaseConfig cfg)
+   {
+      return FWDMariaDBConnectionCustomizer.class;
+   }
+   
+   /**
+    * Activate error handler at the database side.
+    * @param  conn 
+    *         Database connection
+    * @throws SQLException
+    *         on error.
+    */
+   @Override
+   public void activateErrorHandler(Connection conn)
+   throws SQLException
+   {
+      conn.prepareCall("{ call activateErrorHandler()}").executeUpdate();
+   }
+   
+   /**
+    * Reset error handler at the database side.
+    * @param  conn 
+    *         Database connection
+    * @throws SQLException
+    *         on error.
+    */
+   @Override
+   public void resetErrorHandler(Connection conn)
+   throws SQLException
+   {
+      conn.prepareCall("{ call resetErrorHandler()}").executeUpdate();
+   }
+
+   /**
     * Get a new instance of a splitter for DDL scripts. Reuses the splitter for PG dialect.
     * 
     * @return  A new instance of splitter for DDL scripts.
@@ -609,6 +654,26 @@
       return true;
    }
    
+   /** 
+    * Get name of the checkError UDF. 
+    * @return the name of the checkError UDF.  
+    */
+   @Override
+   public String checkErrorFn()
+   {
+      return "checkError_BB";
+   }
+
+   /** 
+    * Get name of the initError UDF. 
+    * @return the name of the initError UDF.  
+    */ 
+   @Override
+   public String initErrorFn()
+   {
+      return "initError_B";
+   }
+
    /**
     * Check if the exception was caused by an error in UDF.
     *

=== modified file 'src/com/goldencode/p2j/persist/dialect/P2JPostgreSQLDialect.java'
--- src/com/goldencode/p2j/persist/dialect/P2JPostgreSQLDialect.java	2023-02-04 14:43:34 +0000
+++ src/com/goldencode/p2j/persist/dialect/P2JPostgreSQLDialect.java	2023-02-12 15:00:56 +0000
@@ -123,6 +123,7 @@
 **     OM  20221026          Excluded table name from index name by default. It will be added as needed by
 **                           dialects.
 **     RAA 20230109          Overrided method getSequenceSetValString().
+**     IAS 20230208          Dialect-specific error handler support.
 */
 
 /*
@@ -196,6 +197,7 @@
 import com.goldencode.p2j.util.LogHelper;
 import com.goldencode.p2j.util.ErrorManager.*;
 import com.goldencode.util.*;
+import com.mchange.v2.c3p0.*;
 import com.goldencode.p2j.cfg.*;
 import com.goldencode.p2j.convert.*;
 import com.goldencode.p2j.directory.DirectoryService;
@@ -2032,6 +2034,19 @@
    }
    
    /**
+    * Get c3p0 ConnectionCustomizer class for the dialect.
+    * @param <T>
+    *        Customizer class  
+    * @param cfg 
+    *        Database configuration.
+    * @return c3p0 ConnectionCustomizer class for the dialect.
+    */
+   @Override
+   public Class<? extends AbstractConnectionCustomizer> connectionCustomizer(DatabaseConfig cfg)
+   {
+      return cfg.isUseJavaUDFs() ? null : FWDPostgreSQLConnectionCustomizer.class;
+   }
+   /**
     * Worker method for {@code generateTriggerDDLs()}. It generates the DDLs needed to create all
     * triggers in a database with a specific schema and using a certain dialect.
     *

=== modified file 'src/com/goldencode/p2j/persist/dialect/P2JSQLServer2008Dialect.java'
--- src/com/goldencode/p2j/persist/dialect/P2JSQLServer2008Dialect.java	2023-01-10 16:58:00 +0000
+++ src/com/goldencode/p2j/persist/dialect/P2JSQLServer2008Dialect.java	2023-02-12 15:01:53 +0000
@@ -43,6 +43,7 @@
 **     RAA 20230109 Overrided method getSequenceSetValString().
 **     SVL 20230110 P2JIndex.components() provides direct access to the components array in order to improve
 **                  performance.
+**     IAS 20230208 Dialect-specific error handler support.
 */
 
 /*
@@ -1363,6 +1364,26 @@
       return false;
    }
 
+   /** 
+    * Get name of the checkError UDF. 
+    * @return the name of the checkError UDF.  
+    */
+   @Override
+   public String checkErrorFn()
+   {
+      return "dbo.checkError_bb";
+   }
+
+   /** 
+    * Get name of the initError UDF. 
+    * @return the name of the initError UDF.  
+    */ 
+   @Override
+   public String initErrorFn()
+   {
+      return "dbo.initError_b";
+   }
+
    /**
     * Check if the exception was caused by error in UDF. 
     * @param e

=== modified file 'src/com/goldencode/p2j/persist/orm/FqlToSqlConverter.java'
--- src/com/goldencode/p2j/persist/orm/FqlToSqlConverter.java	2023-02-04 14:43:34 +0000
+++ src/com/goldencode/p2j/persist/orm/FqlToSqlConverter.java	2023-02-12 15:02:55 +0000
@@ -47,6 +47,7 @@
 **     SVL 20230108 Improved performance by replacing some "for-each" loops with indexed "for" loops.
 **         20221031 Collected fields of "select" query.
 **         20221101 Fixed possible NPE.
+**     IAS 20230208 Dialect-specific error handler support.
 */
 
 /*
@@ -271,6 +272,13 @@
     * Mutable session attributes' values used in the query 
     */
    private final List<SessionAttr> sessionAttrs = new ArrayList<>(); 
+
+   /** The name of the checkError UDF with prepended dot */
+   private final String _checkErrorFn;
+   
+   /** Flag indicating that the query contains error handling */
+   private boolean containsErrorHandling = false;
+
    
    /**
     * The constructor is private. To create an instance of this class, use the {@code getInstance}
@@ -296,6 +304,7 @@
       this.generateUniqueSqlColumnNames = true;
       this.useWordTables = !SchemaDictionary.TEMP_TABLE_DB.equals(schema) && 
                            !db.isDirty() && !db.isMeta() && dialect.useWordTables();
+      this._checkErrorFn = "." + dialect.checkErrorFn();
    }
    
    /**
@@ -347,6 +356,16 @@
    {
       return sessionAttrs;
    }
+
+   /**
+    * Checks if the query contains error handling.
+    * 
+    * @return  {@code true} if the query contains error handling.
+    */
+   public boolean containsErrorHandling()
+   {
+      return containsErrorHandling;
+   }
    /**
     * Check if the query reads _UserTableStat VST. 
     * 
@@ -2481,6 +2500,10 @@
                   }
                   else 
                   {
+                     if (text.equals(dialect.checkErrorFn()) || text.endsWith(_checkErrorFn))
+                     {
+                        containsErrorHandling = true;
+                     }
                      sb.append(text);
                      sb.append("(");
                      if (next.getNumImmediateChildren() == 0)

=== modified file 'src/com/goldencode/p2j/persist/orm/PooledDataSourceProvider.java'
--- src/com/goldencode/p2j/persist/orm/PooledDataSourceProvider.java	2022-10-24 10:38:22 +0000
+++ src/com/goldencode/p2j/persist/orm/PooledDataSourceProvider.java	2023-02-12 15:04:54 +0000
@@ -2,7 +2,7 @@
 ** Module   : PooledDataSourceProvider.java
 ** Abstract : Implementation of DataSourceProvider that offers a pooled DataSource.
 **
-** Copyright (c) 2019-2021, Golden Code Development Corporation.
+** Copyright (c) 2019-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------------Description----------------------------------------
 ** 001 ECF 20191001 Created initial version with basic runtime support.
@@ -11,6 +11,7 @@
 **     ECF 20210910 Minor cleanup.
 **     IAS 20220816 Do not use ConnectionCustomizer for non-PostgreSQL databases.
 **     TW  20221024 Implement support for driver_properties.
+**     IAS 20230208 Dialect-specific error handler support.
 */
 
 /*
@@ -191,14 +192,15 @@
                }
             }
          }
-         if (!cfg.isUseJavaUDFs() && 
-                  (DatabaseManager.getDialect(database) instanceof P2JPostgreSQLDialect))
+         Class<? extends AbstractConnectionCustomizer> customizer = 
+                  DatabaseManager.getDialect(database).connectionCustomizer(cfg);
+         if (ds.getConnectionCustomizerClassName() == null && customizer != null)
+         {
+            ds.setConnectionCustomizerClassName(customizer.getName());
+         }
+         if (!cfg.isUseJavaUDFs() )
          {
             extensions.putIfAbsent("useJavaUdfs", "n");
-            if (ds.getConnectionCustomizerClassName() == null)
-            {
-               ds.setConnectionCustomizerClassName(FWDConnectionCustomizer.class.getName());
-            }
          }
          if (!extensions.isEmpty())
          {

=== modified file 'src/com/goldencode/p2j/persist/orm/Query.java'
--- src/com/goldencode/p2j/persist/orm/Query.java	2023-02-10 09:39:25 +0000
+++ src/com/goldencode/p2j/persist/orm/Query.java	2023-02-12 15:04:48 +0000
@@ -2,7 +2,7 @@
 ** Module   : Query.java
 ** Abstract : Wrapper for FQL statements.
 **
-** Copyright (c) 2019-2022, Golden Code Development Corporation.
+** Copyright (c) 2019-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
 ** 001 ECF 20191001 Created initial version with stubbed methods.
@@ -26,6 +26,7 @@
 **     SBI 20221023 Added a usage of SQLQuery.uniqueResult(Session session, RowStructure rowStructure).
 **     CA  20221031 Javadoc fixes.
 **     IAS 20230209 Fixed ${TZ} placeholder value
+**     IAS 20230208 Dialect-specific error handler support.
 */
 
 /*
@@ -120,6 +121,9 @@
    /** Flag indicating that the query reads from _Lock VST */
    private boolean lockTableRead = false;
 
+   /** Flag indicating that the query contains error handling */
+   private boolean containsErrorHandling = false;
+   
    /**
     * The maximum number of results accepted by the (SELECT) query. Used with {@code firstResult}
     * to configure result pagination.
@@ -353,12 +357,15 @@
             paramCount = fql2sql.getLastConversionParamCount();
             wasRewritten = fql2sql.isQueryWasRewritten();
             userTableStatRead = fql2sql.isUserTableStatRead();
+            this.containsErrorHandling = fql2sql.containsErrorHandling();
             lockTableRead = fql2sql.isLockTableRead();
             if (!wasRewritten)
             {
                cache.accept(this);
             }
-            sqlQuery = Session.createSQLQuery(sql, fql2sql.sessionAttrs(), fql2sql.getParameterPermutation());
+            sqlQuery = Session.createSQLQuery(sql, fql2sql.sessionAttrs(), 
+                     fql2sql.getParameterPermutation()).
+                     containsErrorHandling(containsErrorHandling);
          };
          
          QUERY_PARSE.timer(op);

=== modified file 'src/com/goldencode/p2j/persist/orm/SQLQuery.java'
--- src/com/goldencode/p2j/persist/orm/SQLQuery.java	2023-02-10 09:39:25 +0000
+++ src/com/goldencode/p2j/persist/orm/SQLQuery.java	2023-02-12 15:04:05 +0000
@@ -51,6 +51,7 @@
 **     CA  20230104 If a cached record is incomplete, get the full record from the database when a hydrate is
 **                  is performed.
 **     IAS 20230209 Fixed ${TZ} placeholder value
+**     IAS 20230208 Dialect-specific error handler support.
 */
 
 /*
@@ -172,6 +173,9 @@
    /** Mutable session attributes' values used in the query. */
    private final List<SessionAttr> sessionAttrs; 
    
+   /** Flag indicating that the query contains error handling */
+   private boolean containsErrorHandling = false;
+
    /** The {@code PreparedStatement}. */
    private PreparedStatement stmt;
    
@@ -214,6 +218,18 @@
    }
    
    /**
+    * Set the value of the flag indicating that the query contains error handling.
+    * @param value
+    *        The new value of the flag;
+    * @return <code>this</code>
+    */
+   public SQLQuery containsErrorHandling(boolean value)
+   {
+      this.containsErrorHandling = value;
+      return this;
+   }
+   
+   /**
     * Checks if the query can raise {@code SQLWarning}.
     * 
     * @return  {@code true} if the query can raise {@code SQLWarning}.
@@ -237,6 +253,7 @@
       return this;
    }
    
+
    /**
     * Expand placeholder.
     * @param dialect 
@@ -319,6 +336,7 @@
       
       try
       {
+         activateErrorHandler(session);
          stmt = conn.prepareStatement(sql, scrollMode, readOnlyMode);
          setParameters(stmt, false);
          
@@ -332,7 +350,8 @@
          
          ResultSet resultSet = resultSetArray[0];
          reportSQLWarnings(session);
-         return new ScrollableResults<>(stmt, resultSet, rowStructure, session);
+         return new ScrollableResults<T>(stmt, resultSet, rowStructure, session).
+                    onClose(() -> {resetErrorHandler(session); return null;});
       }
       catch (SQLException exc)
       {
@@ -344,6 +363,10 @@
          }
          throw new PersistenceException("Error scrolling", exc);
       }
+//      finally
+//      {
+//         resetErrorHandler(session);
+//      }
    }
    
    /**
@@ -372,6 +395,7 @@
       
       try
       {
+         activateErrorHandler(session);
          stmt = conn.prepareStatement(sql);
          setParameters(stmt, false);
          
@@ -381,13 +405,18 @@
             log(session.getDatabase(), stmt, () -> resultSetArray[0] = stmt.executeQuery());
          
          ResultSet resultSet = resultSetArray[0];
-         return new ScrollableResults<>(stmt, resultSet, rowStructure, session);
+         return new ScrollableResults<T>(stmt, resultSet, rowStructure, session).
+                  onClose(() -> {resetErrorHandler(session); return null;});
       }
       catch (SQLException exc)
       {
          close();
          throw new PersistenceException("Error scrolling", exc);
       }
+//      finally 
+//      {
+//         resetErrorHandler(session);
+//      }
    }
    
    /**
@@ -439,6 +468,7 @@
       
       try
       {
+         activateErrorHandler(session);
          stmt = conn.prepareStatement(sql);
          setParameters(stmt, false);
          
@@ -489,6 +519,7 @@
       finally
       {
          close();
+         resetErrorHandler(session);
       }
    }
    
@@ -511,6 +542,7 @@
       
       try
       {
+         activateErrorHandler(session);
          stmt = conn.prepareStatement(sql);
          setParameters(stmt, true);
          
@@ -529,6 +561,7 @@
       finally
       {
          close();
+         resetErrorHandler(session);
       }
    }
    
@@ -562,6 +595,7 @@
       
       try
       {
+         activateErrorHandler(session);
          int rowSize = rowStructure.size();
          List<T> ret = new ArrayList<>();
          stmt = conn.prepareStatement(sql);
@@ -640,6 +674,7 @@
       }
       finally
       {
+         resetErrorHandler(session);
          close();
       }
    }
@@ -1022,6 +1057,50 @@
    }
    
    /**
+    * Activate error handler at the database side.
+    * @param  session 
+    *         Database session
+    * @throws SQLException
+    *         on error.
+    * @throws PersistenceException 
+    *         on error.
+    */
+   private void activateErrorHandler(Session session)
+   throws SQLException, PersistenceException
+   {
+      if (!containsErrorHandling)
+      {
+         return;
+      }
+      Query.getDialect(session).activateErrorHandler(session.getConnection());  
+   }
+   
+   /**
+    * Reset error handler at the database side.
+    * @param  session 
+    *         Database session
+    * @throws SQLException
+    *         on error.
+    * @throws PersistenceException 
+    *         on error.
+    */
+   public void resetErrorHandler(Session session)
+   throws PersistenceException
+   {
+      if (!containsErrorHandling)
+      {
+         return;
+      }
+      try
+      {
+         Query.getDialect(session).activateErrorHandler(session.getConnection());
+      }
+      catch (SQLException e)
+      {
+         throw new PersistenceException("Failed to reset error handler", e);
+      }  
+   }
+   /**
     * Sets the value for a parameter at a specified position in a statement. The process is done in recursive
     * manner for arrays and {@code List}s. The {@code pos} is incremented automatically for each scalar
     * parameter configured.

=== modified file 'src/com/goldencode/p2j/persist/orm/ScrollableResults.java'
--- src/com/goldencode/p2j/persist/orm/ScrollableResults.java	2022-10-27 21:27:12 +0000
+++ src/com/goldencode/p2j/persist/orm/ScrollableResults.java	2023-02-12 15:04:30 +0000
@@ -2,13 +2,14 @@
 ** Module   : ScrollableResults.java
 ** Abstract : Allows scrollable access to result set.
 **
-** Copyright (c) 2019-2022, Golden Code Development Corporation.
+** Copyright (c) 2019-2023, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 ECF 20191001 Created initial version, with stubbed methods.
 **     OM  20191111 Added method implementation.
 ** 002 SBI 20220811 Added new version of get method to retrieve selected columns from a row.
 **         20221023 Added a usage of SQLQuery.hydrateRecord(ResultSet, RowStructure, int, Session).
+**     IAS 20230208          Dialect-specific error handler support.
 */
 
 /*
@@ -96,6 +97,9 @@
    /** The {@code Session} to be used.*/
    private final Session session;
    
+   /** On close hook*/
+   private SandboxRun<Void> onClose = () -> null;
+   
    /**
     * Constructs a {@code ScrollableResults} object for further use.
     * 
@@ -129,6 +133,17 @@
    }
    
    /**
+    * Set on close hook
+    * @param hook
+    *        new hook;
+    * @return <code>this</code>
+    */
+   public ScrollableResults<T> onClose(SandboxRun<Void> hook)
+   {
+      this.onClose = hook;
+      return this;
+   }
+   /**
     * Go to result row.
     *
     * @return  {@code true} if there is a result under the cursor and {@code false} otherwise
@@ -339,11 +354,15 @@
 
    /**
     * Obtain the value of a {@code i}-th column of the current row.
+    * @param i 
+    *        column number
+    * @param tClass 
+    *        column 
     *
     * @return  The value on {@code i}-th column of the current row if {@code i} and current row
     *          are valid and {@code null} otherwise.
     */
-   public T get(int i, Class<T> tClass)
+   public T get(int i, Class<T>tClass)
    {
       return execute(() -> rs.getObject(i + 1, tClass), null);
    }
@@ -409,7 +428,7 @@
    public void close()
    throws PersistenceException
    {
-      execute(() -> { stmt.close(); return null; }, null);
+      execute(() -> { stmt.close(); onClose.run(); return null; }, null);
    }
    
    /**

